tag @s remove input_rise
tag @s remove input_held
tag @s[tag=input_left] add input_held
tag @s[tag=input_right] add input_held
tag @s[tag=input_forward] add input_held
tag @s[tag=input_backward] add input_held

# Update direction based on rising inputs
execute if entity @s[scores={maze_t=0..},tag=input_held] run function maze:player/update_direction

# Update position if direction changed or timer ran out
execute if entity @s[scores={maze_t=..0,maze_d=0..}] run function maze:player/update_position
execute if score @s maze_l matches 0 run function maze:player/randomize

# Check ghost collision before and after ghost movement.
execute as @e[tag=ghost,distance=0..1] at @s run function maze:ghost/check_for_player
execute if entity @s[scores={maze_r=3..}] as @n[tag=ghost_r,scores={maze_t=..0}] at @s run function maze:ghost/update_position
execute if entity @s[scores={maze_r=10..}] as @n[tag=ghost_p,scores={maze_t=..0}] at @s run function maze:ghost/update_position
execute if entity @s[scores={maze_r=30..}] as @n[tag=ghost_c,scores={maze_t=..0}] at @s run function maze:ghost/update_position
execute if entity @s[scores={maze_r=50..}] as @n[tag=ghost_o,scores={maze_t=..0}] at @s run function maze:ghost/update_position
execute as @e[tag=ghost,distance=0..1] at @s run function maze:ghost/check_for_player

# Spread red tiles through the body of a dead maze
execute if score @s maze_t matches -1 run function maze:spread_red

# Decrease the timer
scoreboard players remove @s[scores={maze_t=1..}] maze_t 1
scoreboard players remove @e[tag=ghost,scores={maze_t=..30}] maze_t 1
execute unless score @s maze_power_time matches 1.. run scoreboard players remove @e[tag=ghost,scores={maze_t=31..}] maze_t 1


# Reset the round if we got all the pellets
execute if entity @s[scores={maze_r=283..}] run function maze:reset_round
#execute if entity @s[scores={maze_r=10..}] run function maze:reset_round

# Handle countdown tones
execute if entity @s[nbt={data:{countdown:1b}},scores={maze_t=31}] positioned as @n[tag=camera] run playsound minecraft:block.note_block.bit master @a ~ ~ ~ 0.8 0.900
execute if entity @s[nbt={data:{countdown:1b}},scores={maze_t=21}] positioned as @n[tag=camera] run playsound minecraft:block.note_block.bit master @a ~ ~ ~ 0.8 0.900
execute if entity @s[nbt={data:{countdown:1b}},scores={maze_t=11}] positioned as @n[tag=camera] run playsound minecraft:block.note_block.bit master @a ~ ~ ~ 0.8 0.850
execute if entity @s[nbt={data:{countdown:1b}},scores={maze_t=1}] positioned as @n[tag=camera] run playsound minecraft:block.note_block.bit master @a ~ ~ ~ 0.8 0.950
execute if entity @s[nbt={data:{countdown:1b}},scores={maze_t=1}] run data modify entity @s data.countdown set value 0b

# Handle making ghosts blink
execute if score @s maze_power_time matches 180 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 160 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 140 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 120 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 100 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 080 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 060 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 050 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 040 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 030 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 020 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 018 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 016 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 014 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 012 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 008 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 006 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 004 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_b
execute if score @s maze_power_time matches 002 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_w
execute if score @s maze_power_time matches 000 as @e[tag=ghost,sort=nearest,limit=4] run function maze:ghost/blink_stop

execute if score @s maze_power_time matches 1 positioned as @n[tag=camera] run playsound minecraft:block.beacon.deactivate master @a ~ ~ ~ 1 2

execute if score @s maze_power_time matches 0.. run scoreboard players remove @s maze_power_time 1